
	*****************************************
	*	    IFF Module format		*
	*****************************************

; Module ControlBits (Part of "INFO" Chunk)
	rsreset
bt_Ciaa		= 0	; 0 = VBlank (50Hz)	1 = CIAA timer (Beats)
bt_Song		= 1	; 0 = Module		1 = Song (No samples included)
bt_PatPos	= 2	; 0 = 1 PosList		1 = 1 PosList pr. channel
bt_Led		= 3	; 0 = Led off		1 = Led on
;----------------

	; This is the standard IFF format heading...
ModuleData:
	dc.l	"FORM",FileLen
File:	dc.l	"MODL"		; IFFtype = MODULE

;------------

VersionChunk:
	dc.l	"VERS",.chklen
.chkdat	dc.l	310		; version number
	dc.b	'$VER:ProTrackerV3.10 (13/02/93)',0
	cnop	0,2
.chklen = *-.chkdat

;-------

TextChunk:
	dc.l	"TEXT",.chklen
.chkdat	; An ASCII text file written by the module author
	dc.b	'Info text',0
	cnop	0,2
.chklen = *-.chkdat

;-------

InfoChunk:
	dc.l	"INFO",.chklen	; Module Information
.chkdat	ds.b	32		; ModuleName
	dc.b	0		; Controlbits (see ControlBit list)
	dc.b	4		; Number of channels (tracks pr. pattern)
	dc.b	0		; Overall volume (0 -> 255)
	dc.b	6		; Speed ( Def=6 )
	dc.w	125		; Beats/Minutes ( Def=125 {=50Hz} )
	dc.w	0		; Number of Patterns
	dc.w	0		; Number of entries in Pattern List
	dc.w	0		; Number of Instruments
	dc.w	0		; Number of Samples
	dc.w	0		; Number of Sids
.chklen = *-.chkdat

;-------

EffectChunk:
	dc.l	"EFCT",.chkdat
.chkdat	dc.w	0
		; This chunk contains info. of external effects
		; and the number of value bytes for each effect.
		; If this chunk is missing, a default of 1 value
		; byte for each effect will be set.

.chklen = *-.chkdat

;-------

MacroChunk:
	dc.l	"MACR",.chkdat
.chkdat	dc.w	0
		; This chunk contains info. of effects macros
		; the number value bytes for each effect is 1 byte
		; There is a maximum number of 256 macros.
.chklen = *-.chkdat

;-------

PosiChunk:
	dc.l	"PPOS",.chkdat
.chkdat	ds.w	128		; Number of Patternpositons
.chklen = *-.chkdat

;-------

	; This chunk is for future use when a module has variable
	; pattern length...
	; This chunk must appear as many times as there are patterns
	; in the module
PattChunk:
	dc.l	"PTRN",.chklen		; Pattern
.chkdat	dc.w	0	; Number of lines in pattern
			;	Number of lines in chunk =
			;	lines_in_patt*channels
	; Note Byte
	;	$ff -> $88 (-1 -> -120) = Note (10 octaves)
	;	$87 = NilNote
	;	The Note Byte is always followed by the instrument byte
	;	$00 -> $ff
	; Effect byte
	;	$00 -> $7f
	;	The effect byte is always followed by one or more value bytes
	;	$00 -> $ff, $00 -> $ff, ...
	;	(The default number of value bytes is 1)
	; Packed lines
	;	$80 = Pack code
	;	Followed by a byte indicating the number of null-lines

.chklen = *-.chkdat

;-------

	; This chunk must appear as many times as there are instruments
	; in the module
InstrumentChunk:
	dc.l	"INST",.chklen
.chkdat	ds.b	32		; Instrument name

	dc.b	0		; Volume1 (0 -> 255)
	dc.b	0		; Volume2 (0 -> 255)
	dc.w	0		; Attack time (from 0 to vol1)
	dc.w	0		; Decay time (from vol1 to vol2)
	dc.w	0		; Sustain time (delay)
	dc.w	0		; Release time (from vol2 to 0)
				; (Time is defined in number of beats)

	dc.b	0		; Finetune (-8 -> +7)
	dc.b	0		; Sample number in use (neg = SID in use)

	dc.l	0		; Sample play start position
	dc.l	0		; Sample play length
	dc.l	0		; Sample repeat position
	dc.l	0		; Sample repeat length

	dc.w	0		; Automatic arpeggio (Type Minor/Major...)
	dc.w	0		; Automatic note slide (Time)
	dc.w	0		; Automatic vibrato (Time,Depth)

.chklen = *-.chkdat

;-------

	; This chunk must appear as many times as there are sids
	; in the module
SidChunk:
	dc.l	"PSID",.chklen
.chkdat	dc.w	0			;????
.chklen = *-.chkdat

;-------

	; This chunk must appear as many times as there are samples
	; in the module
SampleChunk:
	dc.l	"SMPL",.chklen
.chkdat	ds.b	32		; Sample name
	dc.b	0		; 0 = Normal sample, 1 = Delta encoded sample
	dc.b	0		; Number of bytes(-1) per sample
				; 0 = 1 byte (8 bits sample)
				; 1 = 2 bytes (16 bits sample)
				; (12 bits samples must be saved as 16 bit)
				; ((1 bit sample must be saved as 8))
	; Here the raw sampledata must come...
.chklen = *-.chkdat

;-------
FileLen = *-File

